Freeciv-3.3: /fast/freeciv/nightly/main/tools/fcmp/mpgui_gtk3.c File Reference

Freeciv-3.3

Loading...
Searching...
No Matches
Data Structures | Macros | Functions | Variables
mpgui_gtk3.c File Reference
`#include <stdlib.h>`
`#include <gtk/gtk.h>`
`#include "fc_cmdline.h"`
`#include "fciconv.h"`
`#include "fcintl.h"`
`#include "log.h"`
`#include "mem.h"`
`#include "version.h"`
`#include "download.h"`
`#include "mpcmdline.h"`
`#include "mpdb.h"`
`#include "modinst.h"`

Go to the source code of this file.

## Data Structures

struct | msg_data
struct | pbar_data

## Macros

#define | ML_COL_NAME 0
#define | ML_COL_VER 1
#define | ML_COL_INST 2
#define | ML_COL_TYPE 3
#define | ML_COL_SUBTYPE 4
#define | ML_COL_LIC 5
#define | ML_COL_URL 6
#define | ML_COL_COUNT 7
#define | ML_TYPE 7
#define | ML_NOTES 8
#define | ML_STORE_SIZE 9

## Functions

static gboolean | quit_dialog_callback (void)
static void | modinst_quit (void)
static void | quit_dialog_response (GtkWidget *dialog, gint response)
static void | msg_callback (const char *msg)
static void | pbar_callback (int downloaded, int max)
static gboolean | msg_main_thread (gpointer user_data)
static void | msg_dl_thread (const char *msg)
static gboolean | pbar_main_thread (gpointer user_data)
static void | pbar_dl_thread (int current, int max)
static gboolean | versionlist_update_main_thread (gpointer user_data)
static void | versionlist_update_dl_thread (void)
static gpointer | download_thread (gpointer data)
static void | gui_download_modpack (const char *URL)
static void | install_clicked (GtkWidget *w, gpointer data)
static void | URL_return (GtkEntry *w, gpointer data)
static gboolean | query_main_list_tooltip_cb (GtkWidget *widget, gint x, gint y, gboolean keyboard_tip, GtkTooltip *tooltip, gpointer data)
static void | setup_modpack_list (const char *name, const char *URL, const char *version, const char *license, enum modpack_type type, const char *subtype, const char *notes)
static void | select_from_list (GtkTreeSelection *select, gpointer data)
static void | modinst_setup_widgets (GtkWidget *toplevel)
int | main (int argc, char *argv[])

## Variables

static GtkWidget * | statusbar
static GtkWidget * | progressbar
static GtkWidget * | main_list
static GtkListStore * | main_store
static GtkWidget * | URL_input
static gboolean | downloading = FALSE
struct fcmp_params | fcmp

## Macro Definition Documentation

## ◆ ML_COL_COUNT

#define ML_COL_COUNT 7

Definition at line 62 of file mpgui_gtk3.c.

## ◆ ML_COL_INST

#define ML_COL_INST 2

Definition at line 56 of file mpgui_gtk3.c.

## ◆ ML_COL_LIC

#define ML_COL_LIC 5

Definition at line 59 of file mpgui_gtk3.c.

## ◆ ML_COL_NAME

#define ML_COL_NAME 0

Definition at line 54 of file mpgui_gtk3.c.

## ◆ ML_COL_SUBTYPE

#define ML_COL_SUBTYPE 4

Definition at line 58 of file mpgui_gtk3.c.

## ◆ ML_COL_TYPE

#define ML_COL_TYPE 3

Definition at line 57 of file mpgui_gtk3.c.

## ◆ ML_COL_URL

#define ML_COL_URL 6

Definition at line 60 of file mpgui_gtk3.c.

## ◆ ML_COL_VER

#define ML_COL_VER 1

Definition at line 55 of file mpgui_gtk3.c.

## ◆ ML_NOTES

#define ML_NOTES 8

Definition at line 65 of file mpgui_gtk3.c.

## ◆ ML_STORE_SIZE

#define ML_STORE_SIZE 9

Definition at line 66 of file mpgui_gtk3.c.

## ◆ ML_TYPE

#define ML_TYPE 7

Definition at line 64 of file mpgui_gtk3.c.

## Function Documentation

## ◆ download_thread()

static gpointer download_thread | ( | gpointer | data | ) |

static

Entry point for downloader thread

Definition at line 255 of file mpgui_gtk3.c.

Referenced by gui_download_modpack().

## ◆ gui_download_modpack()

static void gui_download_modpack | ( | const char * | URL | ) |

static

Download modpack, display error message dialogs

Definition at line 279 of file mpgui_gtk3.c.

Referenced by install_clicked(), main(), mpgui::URL_given(), and URL_return().

## ◆ install_clicked()

static void install_clicked | ( | GtkWidget * | w,
|  | gpointer | data
| ) |  |

static

Install modpack button clicked

Definition at line 309 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Entry point of the freeciv-modpack program

Definition at line 559 of file mpgui_gtk3.c.

## ◆ modinst_quit()

static void modinst_quit | ( | void |  | ) |

static

freeciv-modpack quit

Definition at line 71 of file mpgui_gtk3.c.

Referenced by quit_dialog_callback(), and quit_dialog_response().

## ◆ modinst_setup_widgets()

static void modinst_setup_widgets | ( | GtkWidget * | toplevel | ) |

static

Build widgets

Definition at line 428 of file mpgui_gtk3.c.

## ◆ msg_callback()

static void msg_callback | ( | const char * | msg | ) |

static

Progress indications from downloader

Definition at line 127 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets(), and msg_main_thread().

## ◆ msg_dl_thread()

static void msg_dl_thread | ( | const char * | msg | ) |

static

Downloader thread message callback.

Definition at line 166 of file mpgui_gtk3.c.

Referenced by download_thread().

## ◆ msg_main_thread()

static gboolean msg_main_thread | ( | gpointer | user_data | ) |

static

Main thread handling of message sent from downloader thread.

Definition at line 151 of file mpgui_gtk3.c.

Referenced by msg_dl_thread().

## ◆ pbar_callback()

static void pbar_callback | ( | int | downloaded,
|  | int | max
| ) |  |

static

Progress indications from downloader

Definition at line 136 of file mpgui_gtk3.c.

Referenced by pbar_main_thread().

## ◆ pbar_dl_thread()

static void pbar_dl_thread | ( | int | current,
|  | int | max
| ) |  |

static

Downloader thread progress bar callback.

Definition at line 197 of file mpgui_gtk3.c.

Referenced by download_thread().

## ◆ pbar_main_thread()

static gboolean pbar_main_thread | ( | gpointer | user_data | ) |

static

Main thread handling of progressbar update sent from downloader thread.

Definition at line 183 of file mpgui_gtk3.c.

Referenced by pbar_dl_thread().

## ◆ query_main_list_tooltip_cb()

static gboolean query_main_list_tooltip_cb | ( | GtkWidget * | widget,
|  | gint | x,
|  | gint | y,
|  | gboolean | keyboard_tip,
|  | GtkTooltip * | tooltip,
|  | gpointer | data
| ) |  |

static

Callback for getting main list row tooltip

Definition at line 331 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ quit_dialog_callback()

static gboolean quit_dialog_callback | ( | void |  | ) |

static

Popups the quit dialog if download in progress

Definition at line 91 of file mpgui_gtk3.c.

Referenced by main().

## ◆ quit_dialog_response()

static void quit_dialog_response | ( | GtkWidget * | dialog,
|  | gint | response
| ) |  |

static

This is the response callback for the dialog with the message: Are you sure you want to quit?

Definition at line 80 of file mpgui_gtk3.c.

Referenced by quit_dialog_callback().

## ◆ select_from_list()

static void select_from_list | ( | GtkTreeSelection * | select,
|  | gpointer | data
| ) |  |

static

Callback called when entry from main modpack list selected

Definition at line 410 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ setup_modpack_list()

static void setup_modpack_list | ( | const char * | name,
|  | const char * | URL,
|  | const char * | version,
|  | const char * | license,
|  | enum modpack_type | type,
|  | const char * | subtype,
|  | const char * | notes
| ) |  |

static

Build main modpack list view

Definition at line 364 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ URL_return()

static void URL_return | ( | GtkEntry * | w,
|  | gpointer | data
| ) |  |

static

URL entered

Definition at line 320 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ versionlist_update_dl_thread()

static void versionlist_update_dl_thread | ( | void |  | ) |

static

Downloader thread requests versionlist update.

Definition at line 247 of file mpgui_gtk3.c.

Referenced by download_thread().

## ◆ versionlist_update_main_thread()

static gboolean versionlist_update_main_thread | ( | gpointer | user_data | ) |

static

Main thread handling of versionlist update requested by downloader thread

Definition at line 210 of file mpgui_gtk3.c.

Referenced by versionlist_update_dl_thread().

## Variable Documentation

## ◆ downloading

gboolean downloading = FALSE

static

Definition at line 44 of file mpgui_gtk3.c.

Referenced by download_thread(), gui_download_modpack(), and quit_dialog_callback().

## ◆ fcmp

struct fcmp_params fcmp

Initial value:
= {
.list_url = MODPACK_LIST_URL,
.inst_prefix = NULL,
.autoinstall = NULL
}
incite_cost
char * incite_cost
Definition comments.c:74
MODPACK_LIST_URL
#define MODPACK_LIST_URL
Definition modinst.h:30

Definition at line 46 of file mpgui_gtk3.c.

Referenced by download_thread(), main(), and modinst_setup_widgets().

## ◆ main_list

GtkWidget* main_list

static

Definition at line 41 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets().

## ◆ main_store

GtkListStore* main_store

static

Definition at line 42 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets(), setup_modpack_list(), and versionlist_update_main_thread().

## ◆ progressbar

GtkWidget* progressbar

static

Definition at line 40 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets(), and pbar_callback().

## ◆ statusbar

GtkWidget* statusbar

static

Definition at line 39 of file mpgui_gtk3.c.

Referenced by gui_download_modpack(), modinst_setup_widgets(), and msg_callback().

## ◆ URL_input

GtkWidget* URL_input

static

Definition at line 43 of file mpgui_gtk3.c.

Referenced by modinst_setup_widgets(), and select_from_list().